module dp_ram_sync_read
#(
    parameter N = 8, // number of bits
              W = 2  // number of addr bits
) (
    input          clk,
    input          we,
    input  [W-1:0] addr_a, addr_b,
    input  [N-1:0] din_a,
    output [N-1:0] dout_a, dout_b
);

// signal declaration
reg [N-1:0] ram[2**W-1:0];
reg [W-1:0] addr_a_reg, addr_b_reg;

// write operation
always @(posedge clk) begin
    if (we)
       ram[addr_a] <= din_a;
    addr_a_reg <= addr_a;
    addr_b_reg <= addr_b;
end

// read operation
assign dout_a = ram[addr_a_reg];
assign dout_b = ram[addr_b_reg];

endmodule