module sp_ram_sync_read
#(
    parameter N = 8, // number of bits
              W = 2  // number of addr bits
) (
    input          clk,
    input          we,
    input  [W-1:0] addr,
    input  [N-1:0] din,
    output [N-1:0] dout
);

// signal declaration
reg [N-1:0] ram[2**W-1:0];
reg [W-1:0] addr_reg;

// write operation
always @(posedge clk) begin
    if (we)
       ram[addr] <= din;
    addr_reg <= addr;
end

// read operation
assign dout = ram[addr_reg];

endmodule