module register_file
#(
    parameter N = 8, // number of bits
              W = 2  // number of addr bits
) (
    input          clk,
    input          wr_en,
    input  [W-1:0] wr_addr, rd_addr,
    input  [N-1:0] wr_data,
    output [N-1:0] rd_data
);

// signal declaration
reg [N-1:0] array_reg[2**W-1:0];

// write operation
always @(posedge clk) begin
    if (wr_en)
       array_reg[wr_addr] <= wr_data;
end

// read operation
assign rd_data = array_reg[rd_addr];

endmodule