`timescale 1 ns/1 ps

module testbench;

localparam T = 10;
localparam N = 8;
localparam W = 4;

reg          test_clk;
reg  [W-1:0] test_wr_addr, test_rd_addr;
reg          test_wr_en;
reg  [N-1:0] test_wr_data;
wire [N-1:0] test_rd_data;

integer i, j;

register_file
#(
   .N      (N           ),
   .W      (W           )
) uut (
   .clk    (test_clk    ),
   .wr_en  (test_wr_en  ),
   .wr_addr(test_wr_addr),
   .rd_addr(test_rd_addr),
   .wr_data(test_wr_data),
   .rd_data(test_rd_data)
);

always #T test_clk = ~test_clk;

initial begin
   test_clk = 0;
   test_wr_en = 0;
   test_wr_addr = 0;
   test_rd_addr = 0;
   test_wr_data = 0;
   j = 10;
   for (i=0; i<2**W; i=i+1) begin
      test_wr_addr = i;
      test_wr_data = j;
      j = j+5;
      @(negedge test_clk);
   end
   // write to register file
   test_wr_en = 1;
   for (i=0; i<2**W; i=i+1) begin
      test_wr_addr = i;
      test_wr_data = j;
      j = j+5;
      @(negedge test_clk);
   end
   // read from register file
   test_wr_en = 0;
   for (i=0; i<2**W; i=i+1) begin
      test_rd_addr = i;
      @(negedge test_clk);
   end
   $stop;
end

endmodule