`timescale 1 ns/1 ps

module testbench;

localparam T = 10;
localparam N = 8;
localparam W = 4;

reg          test_clk, test_rstb;
reg          test_rd, test_wr;
reg  [N-1:0] test_w_data;
wire         test_empty, test_full;
wire [N-1:0] test_r_data;

integer i, j;

fifo
#(
   .N     (N          ),
   .W     (W          )
) uut (
   .clk   (test_clk   ),
   .rstb  (test_rstb  ),
   .wr    (test_wr    ),
   .rd    (test_rd    ),
   .w_data(test_w_data),
   .empty (test_empty ),
   .full  (test_full  ),
   .r_data(test_r_data)
);

always #T test_clk = ~test_clk;

initial begin
   test_clk = 0;
   test_rstb = 0;
   test_wr = 0;
   test_rd = 0;
   test_w_data = 0;
   @(negedge test_clk) test_rstb = 1;
   // write
   j = 10;
   for (i=0; i<2**W; i=i+1) begin
      test_wr = 1;
      test_w_data = j;
      j = j+5;
      @(negedge test_clk);
   end
   // read
   for (i=0; i<2**W; i=i+1) begin
      test_wr = 0;
      test_rd = 1;
      @(negedge test_clk);
   end
   repeat(5) @(negedge test_clk);
   $stop;
end

endmodule