`timescale 1 ns/1 ps

module testbench;

localparam T = 10;
localparam N = 8;
localparam W = 4;

reg          test_clk;
reg  [W-1:0] test_addr;
reg          test_we;
reg  [N-1:0] test_din;
wire [N-1:0] test_dout;

integer i, j;

sp_ram_async_read
#(
   .N   (N        ),
   .W   (W        )
) uut (
   .clk (test_clk ),
   .we  (test_we  ),
   .addr(test_addr),
   .din (test_din ),
   .dout(test_dout)
);

always #T test_clk = ~test_clk;

initial begin
   test_clk = 0;
   test_we = 0;
   test_addr = 0;
   test_din = 0;
   j = 10;
   for (i=0; i<2**W; i=i+1) begin
      test_addr = i;
      test_din = j;
      j = j+5;
      @(negedge test_clk);
   end
   // write to register file
   test_we = 1;
   for (i=0; i<2**W; i=i+1) begin
      test_addr = i;
      test_din = j;
      j = j+5;
      @(negedge test_clk);
   end
   // read from register file
   test_we = 0;
   for (i=0; i<2**W; i=i+1) begin
      test_addr = i;
      @(negedge test_clk);
   end
   $stop;
end

endmodule