`timescale 1 ns/1 ps

module testbench;

localparam T = 10;
localparam N = 8;
localparam S = 10;

reg          test_clk, test_rstb;
reg          test_push, test_pop;
reg  [N-1:0] test_w_data;
wire         test_empty, test_full;
wire [N-1:0] test_r_data;

integer i, j;

stack
#(
   .N     (N          ),
   .S     (S          )
) uut (
   .clk   (test_clk   ),
   .rstb  (test_rstb  ),
   .push  (test_push  ),
   .pop   (test_pop   ),
   .w_data(test_w_data),
   .empty (test_empty ),
   .full  (test_full  ),
   .r_data(test_r_data)
);

always #T test_clk = ~test_clk;

initial begin
   test_clk = 0;
   test_rstb = 0;
   test_push = 0;
   test_pop = 0;
   test_w_data = 0;
   @(negedge test_clk) test_rstb = 1;
   // push
   j = 10;
   for (i=0; i<S; i=i+1) begin
      test_push = 1;
      test_w_data = j;
      j = j+5;
      @(negedge test_clk);
   end
   // pop
   for (i=0; i<S; i=i+1) begin
      test_push = 0;
      test_pop = 1;
      @(negedge test_clk);
   end
   repeat(5) @(negedge test_clk);
   $stop;
end

endmodule